
$state_bit_idle		equ		1	;    

$task_area_size_log	equ		5	; 32-words for tcb
$task_state		equ		0	;   
$task_full_slice	equ		4	;      
$task_child		equ		8	;    
$task_next		equ		12	;     
$task_parent		equ		16	;    

; ---      
	taskid					;   R0   
	shl	r0, $task_area_size_log		;      TCB
brother_task:	
	inc	r0, $task_next			;     
	mov	r1, (r0)			;  $task_next
	or	r1, r1                          ;   
	jne	try_switch_task                 ;   
	inc	r0, 4				;   $task_parent
parent_task:
	mov	r1, (r0)			;  $task_parent
	or	r1, r1				;   
	je	this_is_kernel_task             ;     
	mov	r0, r1				;  
	jmp	brother_task

try_switch_task:
	mov	r0, r1
	mov	r1, (r0)			;    
	rcr	r1, $state_bit_idle		;   
	jc	go_child_task			; ,    
enter_task:
	inc	r0, 4				;     
	mov	r1, (r0)			;   R1     
	shr	r0, $task_area_size_log		;   TCB   
	idle

this_is_kernel_task:
	mov	r0, r1
go_child_task:					;  ,    
	inc	r0, $task_child			;       
	mov	r1, (r0)			;     
	or	r1, r1				;   ?
	jne	try_switch_task			;     
	inc	r0, 8				;   $task_next
	jmp	parent_task

$some_data	dq	0		


; ---    
$task_control_block_area	equ		0

init_schedule:
	;   TCB 
	load			r0,  $task_control_block_area
	load			r2,  1024
	xor			r1, r1
erase_loop:
	mov			(r0), r1
	inc			r0, 4
	dec			r2
	jne			erase_loop

	load			r0,  4			;  $task_full_slice  
	load			r2, 0x0F3E1000		;     
	mov			(r0), r2		;  
	inc			r0, 4			;  $task_child  
	load			r1,  32			;  $task_state  
	mov			(r0), r1		;     

	load			r1, 36      		;  $task_full_slice   = 32+16
	mov			(r1), r2		;  
	load			r1, 48      		;  $task_parent   = 32+16
	load			r0,  $task_control_block_area
	mov			(r1), r0

leave_scheduler:

